Index: moodle/course/format/weeks/lib.php
--- moodle/course/format/weeks/lib.php Base (1.3)
+++ moodle/course/format/weeks/lib.php Locally Modified (Based On 1.3)
@@ -33,8 +33,8 @@
  * @param array $path An array of keys to the course node
  * @param stdClass $course The course we are loading the section for
  */
-function callback_weeks_load_content(&$navigation, $keys, $course) {
-    $navigation->add_course_section_generic($keys, $course, get_string('week'), 'week');
+function callback_weeks_load_content(&$navigation, $course, $coursenode) {
+    return $navigation->load_generic_course_sections($course, $coursenode, get_string('week'), 'week');
 }
 
 /**
Index: moodle/course/loginas.php
--- moodle/course/loginas.php Base (1.61)
+++ moodle/course/loginas.php Locally Modified (Based On 1.61)
@@ -8,10 +8,7 @@
     $return = optional_param('return', 0, PARAM_BOOL);   // return to the page we came from
 
     if (session_is_loggedinas()) {
-        if (!confirm_sesskey()) {
-            print_error('confirmsesskeybad');
-        }
-
+    require_sesskey();
         session_unloginas();
 
         if ($return and isset($_SERVER["HTTP_REFERER"])) { // That's all we wanted to do, so let's go back
@@ -33,14 +30,9 @@
     }
     $PAGE->set_url($url);
 
-    if (!confirm_sesskey()) {
-        print_error('confirmsesskeybad');
-    }
+require_sesskey();
+$course = $DB->get_record('course', array('id'=>$id), '*', MUST_EXIST);
 
-    if (!$course = $DB->get_record('course', array('id'=>$id))) {
-        print_error("invalidcourseid");
-    }
-
 /// User must be logged in
 
     $systemcontext = get_context_instance(CONTEXT_SYSTEM);
@@ -53,6 +45,7 @@
             print_error('nologinas');
         }
         $context = $systemcontext;
+    $PAGE->set_context($context);
     } else {
         require_login($course);
         require_capability('moodle/user:loginas', $coursecontext);
@@ -78,6 +71,3 @@
     $PAGE->set_title($strloggedinas);
     $PAGE->navbar->add($strloggedinas);
     notice($strloggedinas, "$CFG->wwwroot/course/view.php?id=$course->id");
-
-
-
Index: moodle/lib/adminlib.php
--- moodle/lib/adminlib.php Base (1.452)
+++ moodle/lib/adminlib.php Locally Modified (Based On 1.452)
@@ -5851,7 +5851,7 @@
         'comments',
         'course_list',
         'course_summary',
-        'global_navigation_tree',
+        'navigation',
         'glossary_random',
         'html',
         'loancalc',
@@ -5869,7 +5869,7 @@
         'search',
         'search_forums',
         'section_links',
-        'settings_navigation_tree',
+        'settings',
         'site_main_menu',
         'social_activities',
         'tag_flickr',
Index: moodle/lib/ajax/getnavbranch.php
--- moodle/lib/ajax/getnavbranch.php Base (1.6)
+++ moodle/lib/ajax/getnavbranch.php Locally Modified (Based On 1.6)
@@ -41,22 +41,17 @@
     $instanceid = optional_param('instance', null, PARAM_INT);
 
     // Create a global nav object
-    $navigation = new global_navigation_for_ajax();
+    $navigation = new global_navigation_for_ajax($PAGE);
 
     // If set to true then we need to call toggle display
     $toggledisplay = false;
     if ($instanceid!==null) {
         // Get the db record for the block instance
-        $blockrecords = $DB->get_record('block_instances', array('id'=>$instanceid,'blockname'=>'global_navigation_tree'));
+        $blockrecords = $DB->get_record('block_instances', array('id'=>$instanceid,'blockname'=>'navigation'));
         if ($blockrecords!=false) {
                 // Instantiate a block_instance object so we can access congif
-            $block = block_instance('global_navigation_tree', $blockrecords);
+            $block = block_instance('navigation', $blockrecords);
             // Check if the expansion limit config option has been set and isn't the default [everything]
-            if (!empty($block->config->expansionlimit) && $block->config->expansionlimit > '0') {
-                // Set the expansion limit
-                $navigation->expansionlimit = $block->config->expansionlimit;
-                $toggledisplay = true;
-            }
             if (empty($block->config->showemptybranches) || $block->config->showemptybranches=='no') {
                 $navigation->showemptybranches = false;
             }
@@ -67,13 +62,8 @@
     $expandable = $navigation->initialise($branchtype, $branchid);
     $converter = new navigation_json();
 
-    if ($toggledisplay) {
-        // Toggle display of item types we dont' want to display
-        $navigation->toggle_type_display($navigation->expansionlimit);
-        $converter->set_expansionceiling($navigation->expansionlimit);
-    }
     // Find the actuall branch we are looking for
-    $branch = $navigation->find_child($branchid, $branchtype);
+    $branch = $navigation->find($branchid, $branchtype);
 
     // Stop buffering errors at this point
     $html = ob_get_contents();
Index: moodle/lib/blocklib.php
--- moodle/lib/blocklib.php Base (1.241)
+++ moodle/lib/blocklib.php Locally Modified (Based On 1.241)
@@ -874,7 +874,7 @@
         global $CFG;
 
         if (!isset($CFG->undeletableblocktypes) || (!is_array($CFG->undeletableblocktypes) && !is_string($CFG->undeletableblocktypes))) {
-            $CFG->undeletableblocktypes = array('global_navigation_tree','settings_navigation_tree');
+            $CFG->undeletableblocktypes = array('navigation','settings');
         } else if (is_string($CFG->undeletableblocktypes)) {
             $CFG->undeletableblocktypes = explode(',', $CFG->undeletableblocktypes);
         }
@@ -1775,6 +1775,6 @@
 function blocks_add_default_system_blocks() {
     $page = new moodle_page();
     $page->set_context(get_context_instance(CONTEXT_SYSTEM));
-    $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('global_navigation_tree', 'settings_navigation_tree')), '*', null, true);
+    $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('navigation', 'settings')), '*', null, true);
     $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('admin_bookmarks')), 'admin-*', null, null, 2);
 }
Index: moodle/lib/db/upgrade.php
--- moodle/lib/db/upgrade.php Base (1.387)
+++ moodle/lib/db/upgrade.php Locally Modified (Based On 1.387)
@@ -19,6 +19,15 @@
 // Please do not forget to use upgrade_set_timeout()
 // before any action that may take longer time to finish.
 
+/**
+ *
+ * @global stdClass $CFG
+ * @global stdClass $USER
+ * @global moodle_database $DB
+ * @global core_renderer $OUTPUT
+ * @param int $oldversion
+ * @return bool
+ */
 function xmldb_main_upgrade($oldversion) {
     global $CFG, $USER, $DB, $OUTPUT;
 
@@ -3497,6 +3506,17 @@
         upgrade_main_savepoint($result, 2010041300);
     }
 
+    if ($result && $oldversion < 2010041301) {
+        $sql = "UPDATE {block} SET name=? WHERE name=?";
+        $DB->execute($sql, array('navigation', 'global_navigation_tree'));
+        $DB->execute($sql, array('settings', 'settings_navigation_tree'));
+
+        $sql = "UPDATE {block_instances} SET blockname=? WHERE blockname=?";
+        $DB->execute($sql, array('navigation', 'global_navigation_tree'));
+        $DB->execute($sql, array('settings', 'settings_navigation_tree'));
+        upgrade_main_savepoint($result, 2010041301);
+    }
+
     return $result;
 }
 
Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -50,31 +50,35 @@
  * @copyright 2009 Sam Hemelryk
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
-class navigation_node {
-    /** Used to identify this node a leaf (default) */
+class navigation_node implements renderable {
+    /** @var int Used to identify this node a leaf (default) 0 */
     const NODETYPE_LEAF =   0;
-    /** Used to identify this node a branch, happens with children */
+    /** @var int Used to identify this node a branch, happens with children  1 */
     const NODETYPE_BRANCH = 1;
-    /** Unknown node type */
+    /** @var null Unknown node type null */
     const TYPE_UNKNOWN =    null;
-    /**  System node type */
-    const TYPE_SYSTEM =     0;
-    /**  Category node type */
+    /** @var int System node type 0 */
+    const TYPE_ROOTNODE =   0;
+    /** @var int System node type 1 */
+    const TYPE_SYSTEM =     1;
+    /** @var int Category node type 10 */
     const TYPE_CATEGORY =   10;
-    /**  Course node type */
+    /** @var int Course node type 20 */
     const TYPE_COURSE =     20;
-    /**  Course Structure node type */
+    /** @var int Course Structure node type 30 */
     const TYPE_SECTION =    30;
-    /**  Activity node type, e.g. Forum, Quiz */
+    /** @var int Activity node type, e.g. Forum, Quiz 40 */
     const TYPE_ACTIVITY =   40;
-    /**  Resource node type, e.g. Link to a file, or label */
+    /** @var int Resource node type, e.g. Link to a file, or label 50 */
     const TYPE_RESOURCE =   50;
-    /**  A custom node type, default when adding without specifing type */
+    /** @var int A custom node type, default when adding without specifing type 60 */
     const TYPE_CUSTOM =     60;
-    /**  Setting node type, used only within settings nav */
+    /** @var int Setting node type, used only within settings nav 70 */
     const TYPE_SETTING =    70;
-    /**  Setting node type, used only within settings nav */
+    /** @var int Setting node type, used only within settings nav 80 */
     const TYPE_USER =       80;
+    /** @var int Setting node type, used for containers of no importance 90 */
+    const TYPE_CONTAINER =  90;
 
     /** @var int Parameter to aid the coder in tracking [optional] */
     public $id = null;
@@ -88,7 +92,7 @@
     public $title = null;
     /** @var string A string that can be used to build a help button */
     public $helpbutton = null;
-    /** @var moodle_url|string|null An action for the node (link) */
+    /** @var moodle_url|action_link|null An action for the node (link) */
     public $action = null;
     /** @var pix_icon The path to an icon to use for this node */
     public $icon = null;
@@ -100,13 +104,13 @@
     public $collapse = false;
     /** @var bool If set to true the node will be expanded by default */
     public $forceopen = false;
-    /** @var string An array of CSS classes for the node */
+    /** @var array An array of CSS classes for the node */
     public $classes = array();
-    /** @var array An array of child nodes */
+    /** @var navigation_node_collection An array of child nodes */
     public $children = array();
     /** @var bool If set to true the node will be recognised as active */
     public $isactive = false;
-    /** @var string If set to true the node will be dimmed */
+    /** @var bool If set to true the node will be dimmed */
     public $hidden = false;
     /** @var bool If set to false the node will not be displayed */
     public $display = true;
@@ -116,6 +120,8 @@
     public $mainnavonly = false;
     /** @var bool If set to true a title will be added to the action no matter what */
     public $forcetitle = false;
+    /** @var navigation_node A reference to the node parent */
+    public $parent = null;
     /** @var array */
     protected $namedtypes = array(0=>'system',10=>'category',20=>'course',30=>'structure',40=>'activity',50=>'resource',60=>'custom',70=>'setting', 80=>'user');
     /** @var moodle_url */
@@ -124,54 +130,27 @@
     public static $autofindactive = true;
 
     /**
-     * Establish the node, with either text string or array or properites
+     * Constructs a new navigation_node
      *
-     * Called when first creating the node, requires one argument which can be either
-     * a string containing the text for the node or an array or properties one of
-     * which must be text.
-     *
-     * <code>
-     * $PAGE->navigation->newitem = 'This is a new nav item';
-     *  // or
-     * $properties = array()
-     * $properties['text'] = 'This is a new nav item';
-     * $properties['short'] = 'This is a new nav item';
-     * $properties['action'] = moodle_url($CFG->wwwroot.'/course/category.php');
-     * $properties['icon'] = new pix_icon('i/course', '');
-     * $properties['type'] = navigation_node::TYPE_COURSE;
-     * $properties['key'] = 'newitem';
-     * $PAGE->navigation->newitem = $properties;
-     * </code>
-     *
-     * The following are properties that must/can be set in the properties array
-     * <ul>
-     * <li><b>text</b>: You must set text, if this is not set a coding exception is thrown.</li>
-     * <li><b>short</b> <i>optional</i>: A short description used for navbar optional.</li>
-     * <li><b>action</b> <i>optional</i>: This can be either a {@link moodle_url} for a link, or string that can be directly output in instead of the text.</li>
-     * <li><b>icon</b> <i>optional</i>: The path to an icon to display with the node.</li>
-     * <li><b>type</b> <i>optional</i>: This type of the node, defaults to TYPE_CUSTOM.</li>
-     * <li><b>key</b> <i>optional</i>: This can be set to allow you to easily retrieve a node you have created.</li>
-     * </ul>
-     *
-     * @param string|array $properties
+     * @param array|string $properties Either an array of properties or a string to use
+     *                     as the text for the node
      */
     public function __construct($properties) {
         if (is_array($properties)) {
+            // Check the array for each property that we allow to set at construction.
+            // text         - The main content for the node
+            // shorttext    - A short text if required for the node
+            // icon         - The icon to display for the node
+            // type         - The type of the node
+            // key          - The key to use to identify the node
+            // parent       - A reference to the nodes parent
+            // action       - The action to attribute to this node, usually a URL to link to
             if (array_key_exists('text', $properties)) {
                 $this->text = $properties['text'];
             }
             if (array_key_exists('shorttext', $properties)) {
                 $this->shorttext = $properties['shorttext'];
             }
-            if (array_key_exists('action', $properties)) {
-                $this->action = $properties['action'];
-                if (is_string($this->action)) {
-                    $this->action = new moodle_url($this->action);
-                }
-                if (self::$autofindactive) {
-                    $this->check_if_active();
-                }
-            }
             if (array_key_exists('icon', $properties)) {
                 $this->icon = $properties['icon'];
                 if ($this->icon instanceof pix_icon) {
